Subject: Re: Hard hang in hypervisor!?

From: [email-masked] (Linas Vepstas)
Date: Tue, 9 Oct 2007 16:28:10 -0500

On Tue, Oct 09, 2007 at 04:18:19PM -0500, Nathan Lynch wrote:
> Linas Vepstas wrote:
> > 
> > I was futzing with linux-2.6.23-rc8-mm1 in a power6 lpar when,
> > for whatever reason, a spinlock locked up. The bizarre thing 
> > was that the rest of system locked up as well: an ssh terminal,
> > and also an hvc console.
> > 
> > Breaking into the debugger showed 4 cpus, 1 of which was 
> > deadlocked in the spinlock, and the other 3 in 
> > .pseries_dedicated_idle_sleep
> > 
> > This was, ahhh, unexpected.  What's up with that? Can
> > anyone provide any insight?
> 
> Sounds consistent with a task trying to double-acquire the lock, or an
> interrupt handler attempting to acquire a lock that the current task
> holds.  Or maybe even an uninitialized spinlock.  Do you know which
> lock it was?

Not sure .. trying to find out now. But why would that kill the
ssh session, and the console? Sure, so maybe one cpu is spinning,
but the other three can still take interrupts, right?  The ssh session
should have been generating ethernet card interrupts, and the console
should have been generating hvc interrupts.  

Err ..  it was cpu 0 that was spinlocked.  Are interrupts not
distributed?

Perhaps I should IRC this ... 

--linas